package cn.com.qmth.stmms.biz.user.model;

import cn.com.qmth.stmms.common.utils.AccessControlUtils;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

@Entity
@Table(name = "b_open_account")
public class OpenAccount implements Serializable {

    private static final long serialVersionUID = 6570825224244775263L;

    /**
     * 主键
     */
    @Id
    @GeneratedValue
    private Integer id;

    /**
     * 所属学校ID
     */
    @Column(name = "school_id", nullable = false)
    private Integer schoolId;

    /**
     * 登录名
     */
    @Column(name = "account", length = 64, nullable = false)
    private String account;

    /**
     * 名称
     */
    @Column(name = "name", length = 64, nullable = false)
    private String name;

    /**
     * 状态
     */
    @Column(name = "enable", length = 1, nullable = false, columnDefinition = "tinyint")
    private boolean enable;

    /**
     * 访问令牌
     */
    @Column(name = "access_token", length = 64, nullable = true)
    private String accessToken;

    /**
     * 令牌刷新时间
     */
    @Column(name = "access_token_refresh_time", nullable = true, columnDefinition = "datetime")
    private Date accessTokenRefreshTime;

    /**
     * 账号首次创建时间
     */
    @Column(name = "create_time", nullable = false, columnDefinition = "datetime")
    private Date createTime;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(Integer schoolId) {
        this.schoolId = schoolId;
    }

    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean isEnable() {
        return enable;
    }

    public void setEnable(boolean enable) {
        this.enable = enable;
    }

    public String getAccessToken() {
        return accessToken;
    }

    public Date getAccessTokenRefreshTime() {
        return accessTokenRefreshTime;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public void refreshAccessToken() {
        this.accessToken = AccessControlUtils.randomString();
        this.accessTokenRefreshTime = new Date();
    }

}
